<?php

declare(strict_types=1);

namespace App\Repository;

final class TblRespuestasXUsuarioCursoRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblRespuestasXUsuarioCursoId): object
    {
        $query = 'SELECT * FROM `TblRespuestasXUsuarioCurso` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRespuestasXUsuarioCursoId);
        $statement->execute();
        $TblRespuestasXUsuarioCurso = $statement->fetchObject();
        if (! $TblRespuestasXUsuarioCurso) {
            throw new \Exception('TblRespuestasXUsuarioCurso not found.', 404);
        }

        return $TblRespuestasXUsuarioCurso;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblRespuestasXUsuarioCurso` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblRespuestasXUsuarioCurso): object
    {
        $query = 'INSERT INTO `TblRespuestasXUsuarioCurso` (`IdPreguntaCurso`, `IdCursoUsuario`, `Respuesta`, `FechaRespuesta`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:IdPreguntaCurso, :IdCursoUsuario, :Respuesta, :FechaRespuesta, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblRespuestasXUsuarioCurso->id);
//         $statement->bindParam('fecha', $TblRespuestasXUsuarioCurso->fecha);
        $statement->bindParam('IdPreguntaCurso', $TblRespuestasXUsuarioCurso->IdPreguntaCurso);
        $statement->bindParam('IdCursoUsuario', $TblRespuestasXUsuarioCurso->IdCursoUsuario);
        $statement->bindParam('Respuesta', $TblRespuestasXUsuarioCurso->Respuesta);
        $statement->bindParam('FechaRespuesta', $TblRespuestasXUsuarioCurso->FechaRespuesta);
        $statement->bindParam('field1', $TblRespuestasXUsuarioCurso->field1);
        $statement->bindParam('field2', $TblRespuestasXUsuarioCurso->field2);
        $statement->bindParam('field3', $TblRespuestasXUsuarioCurso->field3);
        $statement->bindParam('field4', $TblRespuestasXUsuarioCurso->field4);
        $statement->bindParam('field5', $TblRespuestasXUsuarioCurso->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblRespuestasXUsuarioCurso, object $data): object
    {
        if (isset($data->fecha)) {
            $TblRespuestasXUsuarioCurso->fecha = $data->fecha;
        }
        if (isset($data->IdPreguntaCurso)) {
            $TblRespuestasXUsuarioCurso->IdPreguntaCurso = $data->IdPreguntaCurso;
        }
        if (isset($data->IdCursoUsuario)) {
            $TblRespuestasXUsuarioCurso->IdCursoUsuario = $data->IdCursoUsuario;
        }
        if (isset($data->Respuesta)) {
            $TblRespuestasXUsuarioCurso->Respuesta = $data->Respuesta;
        }
        if (isset($data->FechaRespuesta)) {
            $TblRespuestasXUsuarioCurso->FechaRespuesta = $data->FechaRespuesta;
        }
        if (isset($data->field1)) {
            $TblRespuestasXUsuarioCurso->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblRespuestasXUsuarioCurso->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblRespuestasXUsuarioCurso->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblRespuestasXUsuarioCurso->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblRespuestasXUsuarioCurso->field5 = $data->field5;
        }

        $query = 'UPDATE `TblRespuestasXUsuarioCurso` SET `fecha` = :fecha, `IdPreguntaCurso` = :IdPreguntaCurso, `IdCursoUsuario` = :IdCursoUsuario, `Respuesta` = :Respuesta, `FechaRespuesta` = :FechaRespuesta, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRespuestasXUsuarioCurso->id);
        $statement->bindParam('fecha', $TblRespuestasXUsuarioCurso->fecha);
        $statement->bindParam('IdPreguntaCurso', $TblRespuestasXUsuarioCurso->IdPreguntaCurso);
        $statement->bindParam('IdCursoUsuario', $TblRespuestasXUsuarioCurso->IdCursoUsuario);
        $statement->bindParam('Respuesta', $TblRespuestasXUsuarioCurso->Respuesta);
        $statement->bindParam('FechaRespuesta', $TblRespuestasXUsuarioCurso->FechaRespuesta);
        $statement->bindParam('field1', $TblRespuestasXUsuarioCurso->field1);
        $statement->bindParam('field2', $TblRespuestasXUsuarioCurso->field2);
        $statement->bindParam('field3', $TblRespuestasXUsuarioCurso->field3);
        $statement->bindParam('field4', $TblRespuestasXUsuarioCurso->field4);
        $statement->bindParam('field5', $TblRespuestasXUsuarioCurso->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblRespuestasXUsuarioCurso->id);
    }

    public function delete(int $TblRespuestasXUsuarioCursoId): void
    {
        $query = 'DELETE FROM `TblRespuestasXUsuarioCurso` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRespuestasXUsuarioCursoId);
        $statement->execute();
    }
}
